/***********************************************************************
* cpiud232.h
*
* CPI-UD232 Windows API
* Copyright (C) CPI Technologies, Inc.
***********************************************************************/

#ifndef CPIUD232_H      /*[*/
#define CPIUD232_H      1

#ifdef __cplusplus
extern  "C"
{
#endif

/*-----------------------------------------------------------------
// 荞݃bZ[WID
//---------------------------------------------------------------*/

#define UD232_WM_TRIG                   0x2000      /* bZ[WID */

/*-----------------------------------------------------------------
// G[R[h
//---------------------------------------------------------------*/
#define UD232_SUCCESS                   0   /* I*/
                                            /* Windows G[ */
#define UD232_ERR_SYSTEM                1   /* GetLastError R[ */
#define UD232_ERR_NO_DEVICE             2   /* gp\ȃfoCXȂ */
#define UD232_ERR_IN_USE                3   /* wfoCX͎gpł */
#define UD232_ERR_INVALID_DEVICENO      4   /* Ș_foCXԍ */
#define UD232_ERR_INVALID_ARGUMENT      5   /* Ȉ */
#define UD232_ERR_INVALID_PORT          6   /* Ș_|[g */
#define	UD232_ERR_TRG_DATA_INVALID      7   /*  |[gĎvf[^Ȃ */
                                            /* DLL [hs */
#define UD232_ERR_DLL                   ( ~0UL )

/*-----------------------------------------------------------------
// ̑
//---------------------------------------------------------------*/
#define UD232_MAX_DEVICES               16
#define UD232_DEVICE_AUTO               ( ( unsigned short )~0 )

/*-----------------------------------------------------------------
// _|[gԍ
//---------------------------------------------------------------*/
#define UD232_PORT_A                    0
#define UD232_PORT_B                    1
#define UD232_PORT_C                    2
#define UD232_PORT_D                    3
#define UD232_MAX_PORTS                 4

/*-----------------------------------------------------------------
// jbg^Cv
//---------------------------------------------------------------*/
#define TYPE_ZD132			1
#define TYPE_ZD232			2
#define TYPE_ZD332			3
#define TYPE_UD132			9
#define TYPE_UD232			10
#define TYPE_UD332			11

/*-----------------------------------------------------------------
// tB^C^[o萔
//---------------------------------------------------------------*/
#define UD232_FILTER_INTERVAL_STOP      0
#define UD232_FILTER_INTERVAL_1260      1
#define UD232_FILTER_INTERVAL_2520      2
#define UD232_FILTER_INTERVAL_5040      3
#define UD232_FILTER_INTERVAL_10080     4
#define UD232_FILTER_INTERVAL_20160     5

/*-----------------------------------------------------------------
// foCX
//---------------------------------------------------------------*/

#define UD232_CCH_VEN                   8
#define UD232_CCH_DEV                   16
#define UD232_CCH_VER                   4

typedef struct
{
    unsigned short  cbCdb;              /* R}h\̂̃oCg */
    unsigned short  cbSdb;              /* Xe[^X\̂̃oCg */
    unsigned long   cbBuff;             /* obt@̃oCg */
    char    sVen[ UD232_CCH_VEN ];      /* Җ */
    char    sDev[ UD232_CCH_DEV ];      /* i */
    char    sVer[ UD232_CCH_VER ];      /* t@[EFAo[W */
} TUD232DI, *PUD232DI;

/*-----------------------------------------------------------------
// |[gĎ
//---------------------------------------------------------------*/

/* [h */
#define UD232_MON_NONE                  0   /* ĎȂ */
#define UD232_MON_ALT                   1   /* Ώۃrbgɕω */
#define UD232_MON_AND                   2   /* ΏۃrbgSv */
#define UD232_MON_OR                    3   /* Ώۃrbgv */

typedef struct  /* |[gĎݒ̍\ */
{
    unsigned char   bMode;      /* [h */
    unsigned char   bMask;      /* ĎΏۃrbg}XN */
    unsigned char   bData;      /* f[^ */
} TUD232TC, *PUD232TC;

#ifdef  WIN32   /*[*/

/*-----------------------------------------------------------------
// Gg
//---------------------------------------------------------------*/

        /* DLL [h */
BOOL WINAPI Ud232DllOpen( void );
        /* DLL  */
BOOL WINAPI Ud232DllClose( void );
        /* ŌɔG[̃R[h擾 */
DWORD WINAPI Ud232GetLastError( WORD pwLogDevice );
        /* DLLAhCõo[W擾 */
BOOL WINAPI Ud232GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );
        /* Cӂ̃foCX̎gp錾 */
BOOL WINAPI Ud232Create( PWORD pwLogDevice, HWND hwnd, UINT uWMCode );
        /* gp̃foCX */
BOOL WINAPI Ud232Close( WORD wLogDevice );
        /* foCX擾 */
BOOL WINAPI Ud232GetDevInfo( WORD wLogDevice, PUD232DI pDevInfo );
        /* [^[XCb`̒l擾 */
BOOL WINAPI Ud232GetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue );
        /* jbg^Cv擾 */
BOOL WINAPI Ud232GetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue );
        /* Cӂ̃|[gf[^ */
BOOL WINAPI Ud232InPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue );

        /* |[gĎl̐ݒ */
BOOL WINAPI Ud232SetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD232TC pTrgCond );

        /* tB^̃TCNAv񐔒l̐ݒ */
BOOL WINAPI Ud232SetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount );

#endif  /*] WIN32 */

#ifdef __cplusplus
}
#endif

#endif  /*] CPIUD232_H */
