/*======================================================================
//  cpiud232.c
//
//  Copyright (C) CPI Technologies, Inc.
//====================================================================*/
#include <windows.h>
#include <tchar.h>
#include <assert.h>
#include "cpiud232.h"

/*======================================================================
// Macro
//====================================================================*/
#define SZ_DLL          _T( "CPIUD232.DLL" )

/*======================================================================
// Type
//====================================================================*/
typedef struct
{
            /*
            // NCAgĂяoGg
            // GetProcAddress ̃GgAɎsGg
            // ǂ炩ł
            */
    FARPROC         pfn;
    FARPROC const   pfnInv; /* ɎsGg */
    LPCSTR const    psz;    /* GNX|[g */
}   TFEE;
typedef struct
{
    TFEE    GetLastError;
    TFEE    GetVersion;
    TFEE    Create;
    TFEE    Close;
    TFEE    GetDevInfo;
    TFEE    GetSwitchValue;
    TFEE    GetUnitType;
    TFEE    InPort;
    TFEE    done;
    TFEE    init;
    TFEE    SetTrgCond;
    TFEE    SetFilter;
    TFEE    end_marker;         /* do NOT remove */
}   TDET;

/*======================================================================
// Statical function
//====================================================================*/
static  DWORD WINAPI InvGetLastError( WORD pwLogDevice );
static  INT_PTR WINAPI InvGetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion );

static  INT_PTR WINAPI InvCreate( PWORD pwLogDevice, HWND hwnd, UINT uWMCode );

static  INT_PTR WINAPI InvClose( WORD wLogDevice );
static  INT_PTR WINAPI InvGetDevInfo( WORD wLogDevice, PUD232DI pDevInfo );
static  INT_PTR WINAPI InvGetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue );
static  INT_PTR WINAPI InvGetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue );
static  INT_PTR WINAPI InvInPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue );
static  INT_PTR WINAPI inv_done( void );
static  INT_PTR WINAPI inv_init( void );

static  INT_PTR WINAPI InvSetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD232TC pTrgCond );
static  INT_PTR WINAPI InvSetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount );

static  BOOL det_get( void );
static  void det_inv( void );

/*======================================================================
// Statical variable
//====================================================================*/
static  HMODULE s_hDll = NULL;
static  TDET s_det =
{
{   ( FARPROC )InvGetLastError,
            ( FARPROC )InvGetLastError,
            "Ud232GetLastError"
            },
{   InvGetVersion,      InvGetVersion,      "Ud232GetVersion" },
{   InvCreate,          InvCreate,          "Ud232Create" },
{   InvClose,           InvClose,           "Ud232Close" },
{   InvGetDevInfo,      InvGetDevInfo,      "Ud232GetDevInfo" },
{   InvGetSwitchValue,  InvGetSwitchValue,  "Ud232GetSwitchValue" },
{   InvGetUnitType,     InvGetUnitType,     "Ud232GetUnitType" },
{   InvInPort,          InvInPort,          "Ud232InPort" },
{   inv_done,           inv_done,           "ud232_done" },
{   inv_init,           inv_init,           "ud232_init" },

{   InvSetTrgCond,      InvSetTrgCond,      "Ud232SetTrgCond" },
{   InvSetFilter,       InvSetFilter,       "Ud232SetFilter" },
{   NULL,               NULL,               NULL }
};

/*======================================================================
//      DLL [h
//      
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232DllOpen( void )
{
    if ( NULL != s_hDll )
    {
        return TRUE;                    /* [hς݂͐ */
    }
    s_hDll = LoadLibrary( SZ_DLL );
    if ( NULL == s_hDll )
    {
        return FALSE;
    }
    if ( ! det_get() )
    {
        ( void )Ud232DllClose();
        return FALSE;
    }
    return TRUE;
}
/*======================================================================
//      DLL 
//      
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232DllClose( void )
{
    if ( NULL == s_hDll )
    {
        return TRUE;                    /* Jς݂͐ */
    }

    det_inv();

    if ( ! FreeLibrary( s_hDll ) )
    {
        return FALSE;
    }

    s_hDll = NULL;

    return TRUE;
}
/*======================================================================
//      ŌɔG[̃R[h擾
//      iDev    G[foCX̘_foCXԍ
// ߂l   G[R[h
//====================================================================*/
DWORD WINAPI Ud232GetLastError( WORD pwLogDevice )
{
    assert( NULL != s_det.GetLastError.pfn );
    return ( DWORD )( *s_det.GetLastError.pfn )( pwLogDevice );
}
/*======================================================================
//      DLLAhCõo[Wԍ擾
//      pdwDllVersion
//                  DLL o[Wԍi[̈̃AhX
//          pdwDriverVersion
//                  hCoo[Wԍi[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232GetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion )
{
    assert( NULL != s_det.GetVersion.pfn );
    return ( BOOL )( *s_det.GetVersion.pfn )( pdwDllVersion, pdwDriverVersion );
}
/*======================================================================
//      Cӂ̃foCX̎gp錾
//      pwLogDevice gpfoCX̘_foCXԍi[AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232Create( PWORD pwLogDevice, HWND hwnd, UINT uWMCode )
{
    assert( NULL != s_det.Create.pfn );
    return ( BOOL )( *s_det.Create.pfn )( pwLogDevice, hwnd, uWMCode );
}
/*======================================================================
//      gp̃foCX
//      wLogDevice  foCX̘_foCXԍ
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232Close( WORD wLogDevice )
{
    assert( NULL != s_det.Close.pfn );
    return ( BOOL )( *s_det.Close.pfn )( wLogDevice );
}
/*======================================================================
//      wfoCX̃foCX擾
//      wLogDevice  foCX擾foCX̘_foCXԍ
//          pDevInfo    foCXi[\̂̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232GetDevInfo( WORD wLogDevice, PUD232DI pDevInfo )
{
    assert( NULL != s_det.GetDevInfo.pfn );
    return ( BOOL )( *s_det.GetDevInfo.pfn )( wLogDevice, pDevInfo );
}
/*======================================================================
//      [^[XCb`̒l擾
//      wLogDevice      l擾foCX̘_foCXԍ
//          pdwSwitchValue  li[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232GetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue )
{
    assert( NULL != s_det.GetSwitchValue.pfn );
    return ( BOOL )( *s_det.GetSwitchValue.pfn )( wLogDevice, pdwSwitchValue );
}
/*======================================================================
//      jbg^Cv̒l擾
//      wLogDevice       l擾foCX̘_foCXԍ
//          pdwUnitTypeValue li[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232GetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue )
{
    assert( NULL != s_det.GetUnitType.pfn );
    return ( BOOL )( *s_det.GetUnitType.pfn )( wLogDevice, pdwUnitTypeValue );
}
/*======================================================================
//      Cӂ̃|[gf[^
//      wLogDevice  ͂foCX̘_foCXԍ
//          dwLogPort   ͂_|[g
//          pbInValue   ̓f[^i[̈̃AhX
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232InPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue )
{
    assert( NULL != s_det.InPort.pfn );
    return ( BOOL )( *s_det.InPort.pfn )( wLogDevice, dwLogPort, pbInValue );
}

//----tB^----------------------------------------------------------
/*======================================================================
//      tB^l̐ݒ
//      iDev    lݒ肷foCX̘_foCXԍ
//          dVal    tB^lf[^(tB^[h[0],tB^}XN[1],tB^f[^[2])
// ߂l    TRUE
//          s FALSE
//====================================================================*/
//BOOL WINAPI Ud232SetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUd232PTRGCOND pTrgCond )
BOOL WINAPI Ud232SetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD232TC pTrgCond )
{
    assert( NULL != s_det.SetTrgCond.pfn );
    return ( BOOL )( *s_det.SetTrgCond.pfn )( wLogDevice, dwLogPort, pTrgCond );
}
/*======================================================================
//      tB^TCNAv񐔂̐ݒ
//      wLogDevice  lݒ肷foCX̘_foCXԍ
//          bInterval   tB^[TCNl
//              0: 21.33uS * 6 * 0UL        0mS  (~)
//              1: 21.33uS * 6 * 1000UL   128mS
//              2: 21.33uS * 6 * 2000UL   256mS 
//              3: 21.33uS * 6 * 3000UL   384mS 
//              4: 21.33uS * 6 * 8000UL   1024mS 
//              5: 21.33uS * 6 * 16000UL  2048mS 
//          bCount      v񐔁iCӁj
//
// ߂l    TRUE
//          s FALSE
//====================================================================*/
BOOL WINAPI Ud232SetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount )
{
    assert( NULL != s_det.SetFilter.pfn );
    return ( BOOL )( *s_det.SetFilter.pfn )( wLogDevice, bInterval, bCount);
}

/*----------------------------------------------------------------------
// ɎsGg
//--------------------------------------------------------------------*/
static  DWORD WINAPI InvGetLastError( WORD pwLogDevice )
{
    ( void )pwLogDevice;
    return UD232_ERR_DLL;
}
static  INT_PTR WINAPI InvGetVersion( PDWORD pdwDllVersion, PDWORD pdwDriverVersion )
{
    ( void )pdwDllVersion;
    ( void )pdwDriverVersion;
    return FALSE;
}
static  INT_PTR WINAPI InvCreate( PWORD pwLogDevice, HWND hwnd, UINT uWMCode  )
{
    ( void )pwLogDevice;
    ( void )hwnd;
    ( void )uWMCode;
    return FALSE;
}
static  INT_PTR WINAPI InvClose( WORD wLogDevice )
{
    ( void )wLogDevice;
    return FALSE;
}
static  INT_PTR WINAPI InvGetDevInfo( WORD wLogDevice, PUD232DI pDevInfo )
{
    ( void )wLogDevice;
    ( void )pDevInfo;
    return FALSE;
}
static  INT_PTR WINAPI InvGetSwitchValue( WORD wLogDevice, PDWORD pdwSwitchValue )
{
    ( void )wLogDevice;
    ( void )pdwSwitchValue;
    return FALSE;
}
static  INT_PTR WINAPI InvGetUnitType( WORD wLogDevice, PDWORD pdwUnitTypeValue )
{
    ( void )wLogDevice;
    ( void )pdwUnitTypeValue;
    return FALSE;
}
static  INT_PTR WINAPI InvInPort( WORD wLogDevice, DWORD dwLogPort, PBYTE pbInValue )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )pbInValue;
    return FALSE;
}
static  INT_PTR WINAPI inv_done( void )
{
    return FALSE;
}
static  INT_PTR WINAPI inv_init( void )
{
    return FALSE;
}

// static  INT_PTR WINAPI InvSetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUd232PTRGCOND pTrgCond )
static  INT_PTR WINAPI InvSetTrgCond( WORD wLogDevice, DWORD dwLogPort, PUD232TC  pTrgCond )
{
    ( void )wLogDevice;
    ( void )dwLogPort;
    ( void )pTrgCond;
    return FALSE;
}
static  INT_PTR WINAPI InvSetFilter( WORD wLogDevice, BYTE bInterval, BYTE bCount )
{
    ( void )wLogDevice;
    ( void )bInterval;
    ( void )bCount;
    return FALSE;
}
//#endif  /*]*/

/*----------------------------------------------------------------------
//      Gg擾
//      
// ߂l    TRUE
//          s FALSE
//--------------------------------------------------------------------*/
static  BOOL det_get( void )
{
    TFEE*   pfe;

    for ( pfe = ( TFEE* )&s_det; NULL != pfe->psz; pfe++ )
    {
        pfe->pfn = GetProcAddress( s_hDll, pfe->psz );
        if ( NULL == pfe->pfn )
        {
            pfe->pfn = pfe->pfnInv;

            return FALSE;
        }
    }

    assert( NULL != s_det.init.pfn );

    return ( BOOL )( *s_det.init.pfn )();
}
/*----------------------------------------------------------------------
//      Gg
//      
// ߂l    TRUE
//          s FALSE
//--------------------------------------------------------------------*/
static  void det_inv( void )
{
    TFEE*   pfe;

    assert( NULL != s_det.done.pfn );
    ( void )( *s_det.done.pfn )();

    for ( pfe = ( TFEE* )&s_det; NULL != pfe->psz; pfe++ )
    {
        pfe->pfn = pfe->pfnInv;
    }
}
